/*
	vim: set ai ic sw=4 nows
*/

#include	<errno.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

int main(int argc, char *argv[])
{
	int result = -1;

	fprintf(stdout, "\nDocName version 1.0 by Harry Ohlsen\n\n");

	if (argc == 3)
	{
		FILE	*document = fopen(argv[1], "r+b");

		if (document == NULL)
		{
			fprintf(stdout, "docname: failed to read '%s'; error is %s\n",
					argv[1], strerror(errno));
		}
		else
		{
			int   c;
			int   i;
			int   newNameLength = strlen(argv[2]);
			char  oldName[100];
			char *o				= oldName;

			rewind(document);

			/*
			** Check that the new name is no longer than the current one ...
			*/

			while ((c = fgetc(document)) != EOF)
			{
				if (c == '\0')
					break;
				else
					*o++ = c;
			}

			*o = '\0';

			if ((o - oldName) < newNameLength) 
			{
				fprintf(stdout, "Sorry, the current document name\n");
				fprintf(stdout, "is only %d characters long, so you\n", i);
				fprintf(stdout, "must pick a new name that is no\n");
				fprintf(stdout, "longer than that.\n\n");
			}
			else
			{
				/*
				** OK. We know we can happily scribble over the
				** first newNameLength bytes of the file, so go
				** ahead ...
				*/

				rewind(document);

				fprintf(document, "%s%c", argv[2], 0);

				fprintf(stdout, "The document's name has been changed\n");

				fprintf(stdout, "from \"%s\" to \"%s\".\n\n", oldName,
					    argv[2]);

				result = 0;
			}

			fclose(document);
		}
	}
	else
	{
		fprintf(stdout, "Usage: docname doc-file new-name\n\n");

		fprintf(stdout, "where doc-file is the Doc file whose\n");
		fprintf(stdout, "name you wish to change, and new-name\n");
		fprintf(stdout, "is the name you wish to give it.\n\n");

		fprintf(stdout, "Note that if the new name is longer\n");
		fprintf(stdout, "than the current one you will receive\n");
		fprintf(stdout, "an error message.\n\n");

		fprintf(stdout, "Also, if the new name you wish to give\n");
		fprintf(stdout, "the document contains spaces, remember\n");
		fprintf(stdout, "to put it in quotes.\n\n");
	}

	return result;
}

